# vasil@vasil.com

buildtext(t : ref TagNode) : string
{
	s := "<?xml version=\"1.0\"?>\n<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.1//EN\"\t\"http://www.wapforum.org/DTD/wml_1.1.xml\">\n";
	return s + buildtextr("", t);
}

buildtextr(ind : string, t : ref TagNode) : string
{
	s := "";
	tagname := tagtostring(t.tag);

	if(t.tag == LITERAL_C)
		s += ind + t.text + "\n";
	else
	{
		s += ind;
		s += "<" + tagname;

		aa := t.attribs;
		while(aa != nil)
		{
			a := hd aa;
			p := hd attrtagtostringlist(a.tag);
			val := a.text;

			if(hassubstring(p, "="))
			{
				# TODO: de-uglify this please!

				case int a.tag
				{
				int ATT_HREF_HTTP =>	val = val[7:];
				int ATT_HREF_HTTPS =>	val = val[8:];
				int ATT_SRC_HTTP =>		val = val[7:];
				int ATT_SRC_HTTPS =>	val = val[8:];
				}
				s +=" " + p + val +"\"";
			}
			else
			{
				s +=" " + p +"=\"" + val +"\"";
			}
			aa = tl aa;
		}

		if(t.subtags == nil)
		{
			s += "/>\n";
		}
		else
		{
			s += ">\n";
			ll := t.subtags;
			while(ll != nil)
			{
				s += buildtextr(ind + "\t", hd ll);
				ll = tl ll;
			}
			s += ind + "</" + tagname + ">\n";
		}
	}
	return s;
}
