# vasil@vasil.com
implement UrlTest;

include "sys.m";
include "draw.m";
include "string.m";
include "url.m";

sys: Sys;
draw: Draw;
str : String;
url : Url;
ParsedUrl : import url;

baseurl : ParsedUrl;

include "urlcode.b";

UrlTest: module
{
	init:	fn(ctxt: ref Draw->Context, argv: list of string);
};

init(nil: ref Draw->Context, nil: list of string)
{
	sys		= load Sys		Sys->PATH;
	draw	= load Draw		Draw->PATH;
	str		= load String	String->PATH;
	url		= load Url		Url->PATH;

	url->init();

	s := "file://localhost/wml/fonts.wml#2";
	u := *(url->makeurl(s));
	sys->print("%s\n\n", s);
	dumpurl(ref u);

	s = "http://9volt.com/wml/fonts.wml#2";
	u = *(url->makeurl(s));
	sys->print("%s\n\n", s);
	dumpurl(ref u);
}