#vasil@vasil.com

openfile(f : string) : ref Sys->FD
{
	fd := sys->open(f, Sys->OREAD);
	if(fd == nil)
	{
		sys->fprint(stderr, "openfile: can't open %s\n", f);
		return nil;
	}
	return fd;
}

loadfile(fd : ref Sys->FD) : array of byte
{
	if(fd == nil)
		return nil;
	retbuf, tempbuf : array of byte;
	end := 0;

	buf := array[Sys->ATOMICIO] of byte;
	while ( (nbyte := sys->read(fd, buf, len buf)) > 0 )
	{
		tempbuf = array [end + nbyte] of byte;
		tempbuf[0:] = retbuf[0:];
		tempbuf[end:] = buf[0:nbyte];
		retbuf = tempbuf;
		end += nbyte;
	}
	return retbuf;
}
