#vasil@vasil.com

# converts multibyte value in b to int, returns (number of bytes, value)

multibytetoint(b : array of byte) : (int, int)
{
	val : byte;

	ret := 0;
	i := 0;
	while(1)
	{
		val = b[i];
		ret = (ret << 7) | int (val & byte 16r7f);
		i++;
		if((val & byte 16r80) == byte 0)
			break;
	}
	return (i, ret);
}
