# vasil@vasil.com

TagNode.getchild(t : self ref TagNode, ttype : byte) : ref TagNode
{
	ss := t.subtags;
	while(ss != nil)
	{
		s := hd ss;
		if(ttype == s.tag)
		{
			return s;
		}
		ss = tl ss;
	}
	return nil;
}

TagNode.getnthchild(t : self ref TagNode, index : int) : ref TagNode
{
	i := 0;
	ll := t.subtags;
	while(ll != nil)
	{
		if(index == i)
			return hd ll;
		ll = tl ll;
		i++;
	}
	return nil;
}

TagNode.getattr(t : self ref TagNode, ttype : byte) : string
{
	aa := t.attribs;
	while(aa != nil)
	{
		a := hd aa;
		if(ttype == a.tag)
			return a.text;
		aa = tl aa;
	}
	return "";
}

TagNode.getnthattr(t : self ref TagNode, index : int) : ref TagNode
{
	i := 0;
	aa := t.attribs;
	while(aa != nil)
	{
		if(index == i)
			return hd aa;
		aa = tl aa;
		i++;
	}
	return nil;
}
