# vasil@vasil.com


#TODO: is this bugged?
currentdir(s : string) : string
{
	i := len s - 1;
	while(i > 0)
	{
		if(s[i] == '/')
			return s[0: i+1];
		i--;
	}
	return nil;
}

applyrelative(u : ParsedUrl) : ParsedUrl
{
	newu := baseurl;

	#sys->print("newu: %s\n", newu.tostring());

	if(u.scheme != Url->NOSCHEME && u.scheme != newu.scheme)
	{
		newu.scheme = u.scheme;
		newu.user = u.user;
		newu.passwd = u.passwd;
		newu.host = u.host;
#		newu.port = u.port;
		newu.pstart = u.pstart;
		newu.path = u.path;
		newu.query = u.query;
		newu.frag = u.frag;
	}
	else if(u.user != nil)
	{
		newu.user = u.user;
		newu.passwd = u.passwd;
		newu.host = u.host;
#		newu.port = u.port;
		newu.pstart = u.pstart;
		newu.path = u.path;
		newu.query = u.query;
		newu.frag = u.frag;
	}
	else if(u.passwd != nil)
	{
		newu.passwd = u.passwd;
		newu.host = u.host;
#		newu.port = u.port;
		newu.pstart = u.pstart;
		newu.path = u.path;
		newu.query = u.query;
		newu.frag = u.frag;
	}
	else if(u.host != nil)
	{
		newu.host = u.host;
#		newu.port = u.port;
		newu.pstart = u.pstart;
		newu.path = u.path;
		newu.query = u.query;
		newu.frag = u.frag;
	}
	else if(u.port != nil && u.port != newu.port)
	{
#		newu.port = u.port;
		newu.pstart = u.pstart;
		newu.path = u.path;
		newu.query = u.query;
		newu.frag = u.frag;
	}
	else if(u.pstart != nil && u.pstart != newu.pstart)
	{
		newu.pstart = u.pstart;
		newu.path = u.path;
		newu.query = u.query;
		newu.frag = u.frag;
	}
	else if(u.path != nil && u.path != newu.path)
	{
		newu.path = currentdir(newu.path) + u.path;
		newu.query = u.query;
		newu.frag = u.frag;
	}
	else if(u.query != nil && u.query != newu.query)
	{
		newu.query = u.query;
		newu.frag = u.frag;
	}
	else if(u.frag != nil && u.frag != newu.frag)
	{
		newu.frag = u.frag;
	}

	return newu;
}

dumpurl(u : ref ParsedUrl)
{
	#sys->print("%s://%s:%s@%s:%s/%s?%s#%s\n",
	sys->print("scheme: \t%s\n", schemetosring(u.scheme));
	sys->print("  user: \t%s\n", u.user);
	sys->print("passwd: \t%s\n", u.passwd);
	sys->print("  host: \t%s\n", u.host);
	sys->print("  port: \t%s\n", u.port);
	sys->print("pstart: \t%s\n", u.pstart);
	sys->print("  path: \t%s\n", u.path);
	sys->print(" query: \t%s\n", u.query);
	sys->print("  frag: \t%s\n", u.frag);
	sys->print("[%s]\n\n", u.tostring());
}

schemetosring(i : int) : string
{
	s : string;
	case i
	{
	Url->NOSCHEME => s = "NOSCHEME";
	Url->HTTP =>		s = "HTTP";
	Url->HTTPS =>	s = "HTTPS";	
	Url->FTP =>		s = "FTP";	
	Url->FILE =>		s = "FILE";	
	Url->GOPHER =>	s = "GOPHER";	
	Url->MAILTO =>	s = "MAILTO";	
	Url->NEWS =>		s = "NEWS";	
	Url->NNTP =>		s = "NNTP";	
	Url->TELNET =>	s = "TELNET";	
	Url->WAIS =>		s = "WAIS";	
	Url->PROSPERO =>	s = "PROSPERO";	
	Url->JAVASCRIPT =>s = "JAVASCRIPT";	
	Url->UNKNOWN =>	s = "UNKNOWN";	
	}
	return s;
}

isurl(u : ref ParsedUrl) : int
{
	r : int;
	case u.scheme
	{
	Url->FILE or
	Url->NOSCHEME or
	Url->JAVASCRIPT or
	Url->UNKNOWN	=> r = 0;

	Url->HTTP or
	Url->HTTPS or
	Url->FTP or 	
	Url->GOPHER or
	Url->MAILTO or
	Url->NEWS or
	Url->NNTP or
	Url->TELNET or
	Url->WAIS or
	Url->PROSPERO => r = 1;
	}
	return r;
}

cardof(u : ref ParsedUrl) : string
{
	return u.frag;
}

fileof(u : ParsedUrl) : (string, ParsedUrl)
{

#TODO: is url broken?
	s := u.path;
	(l ,r) := str->splitstrl(s, "#");
#	sys->print("fileof: %s\t%s\t%s\n", s, l, r);
######

	if(r != nil)
	{
		u.path = l;
		u.frag = r[1:];
	}
# TODO: is there a fix for url?

	return (l, u);
}
